package org.databene.dbsanity.db;

import java.sql.Connection;

/**
 * Represents a database schema
 * @since 1.0
 * @author Björn Kellermann
 */
public class DbSchema extends AbstractDbPackage{

	protected Connection connection;
	
	public DbSchema(String name, Connection connection) {
		super(name);
		this.connection = connection;
	}

	public Connection getConnection() {
		return connection;
	}
	
	/*
	 * Factory method to retrieve or create new tables.
	 * Registers new table within schema and named package.
	 */
	public DbTable getDbTable(String name, AbstractDbPackage dbPackage) {
		DbTable res = tables.get(name);
		if (res == null) {
			res = new DbTable(name, dbPackage, this);
			this.register(res);
			dbPackage.register(res);
		}
		return res;
	}
}
